#include <iostream>
#include <vector>

#include "Ressource.h"
#include "City.h"
#include "Decoration.h"
#include "Hexagon.h"

int main(int argc, char* argv[]) {
    // Init all resources
    std::vector<Ressource> woods;
    std::vector<Ressource> stones;
    std::vector<Ressource> irons;
    std::vector<Ressource> wheats;
    std::vector<int> ressources_q = {10, 20, 50, 100, 150};
    
    for (int i : ressources_q) {
        woods.emplace_back("Wood", i);
        stones.emplace_back("Stone", i);
        irons.emplace_back("Iron", i);
        wheats.emplace_back("Wheat", i);
    }

    City khamuls_tower_c("Khamûl's Tower");
    City bazylan_c("Bazylan");
    City mordor_c("Mordor");

    Decoration angmar_banner("Angmar's Banner");

    Hexagon hexagon_0_1(wheats[1]);
    Hexagon hexagon_0_3(irons[2]);

    Hexagon hexagon_1_0(bazylan_c);
    Hexagon hexagon_1_2(khamuls_tower_c);
    Hexagon hexagon_1_4(wheats[0]);

    Hexagon hexagon_2_1(angmar_banner);
    Hexagon hexagon_2_3(stones[0]);
    Hexagon hexagon_2_5(mordor_c);

    hexagon_1_0.setBottomRight(&hexagon_2_1);
    hexagon_1_0.setBottomLeft(&hexagon_0_1);

    hexagon_1_2.setTop(&hexagon_1_0);
    hexagon_1_2.setBottomRight(&hexagon_2_3);
    hexagon_1_2.setBottomLeft(&hexagon_0_3);

    hexagon_1_4.setTop(&hexagon_1_2);
    hexagon_1_4.setBottomRight(&hexagon_2_5);



    hexagon_0_1.printAll();
    hexagon_0_3.printAll();
    hexagon_1_0.printAll();
    hexagon_1_2.printAll();
    hexagon_1_4.printAll();
    hexagon_2_1.printAll();
    hexagon_2_3.printAll();
    hexagon_2_5.printAll();

    return 0;
}
